/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include <stdlib.h>
#include <stdio.h>

#include <SDL/SDL.h>
#include "nSX2.h"
#include "plugin_gs_04/PS2Edefs.h"
#include "muGUI/muGUI.h"





        /*
        Freq CPU = 300 Mhz
	    436MIPS ( Million of Instruction per Second )
	    436 000 000
	    */

void ComputeInstructionsPerSec( ) {
        static _u32	PreviousTime= 0;
        static _u32	PreviousNbInstruction = 0;
        
        _u32	CurrentTime;
        float	InstPerSec;
        
        
        CurrentTime = SDL_GetTicks();
	
		if ( ( CurrentTime - PreviousTime ) > 1000 ) {


			InstPerSec = (float)(( MipsCpu.Nb_instructions - PreviousNbInstruction ) * ( ( CurrentTime - PreviousTime ) / 1000 )) / 1000000.0;

			printf("\rCPU Speed:%10.6f MIPS",InstPerSec);
			fflush(stdout);
	
			PreviousNbInstruction = MipsCpu.Nb_instructions;
			PreviousTime = 	CurrentTime;
		}
	
	
	
}




void GSUpdate() {

        static _u64 LastRefresh = 0;
 
		ComputeInstructionsPerSec( );

        
        if ( ( MipsCpu.Nb_instructions  -   LastRefresh )  > 100000 ) {
        
        		
        		       		
        
                if ( (_u64)MipsCpu.Nb_instructions > (_u64) 0xFFFFFFFFFFFF0000 ) MipsCpu.Nb_instructions = 0;
        
               	//if (  GSread64( 0x12000400) != 0x2000 ) {
            		
          		
            		
            		if ( nSX2GUI.myWid[ 0 ].Status != MUGUI_WID_STATUS_HIDE  ) {
            			nSX2GUI.myWid[0].NeedRefresh =  TRUE;	
            			GSvsync();
                	}
                
                    LastRefresh = MipsCpu.Nb_instructions;
                               
                    
                    
               //    }
        }
                


        



}









