/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

/* WIDGET TYPE */
#define MUGUI_WID_IMAGE 1
#define MUGUI_WID_TEXT 	2



/* WIDGET INTERNAL STATUS */
#define	MUGUI_WID_STATUS_SHOW	1
#define	MUGUI_WID_STATUS_HIDE	2
#define MUGUI_WID_STATUS_MOVED	4


/*TITLE CLISK IS...*/
#define MUGUI_WID_TITLEBAR_OTHER	1
#define MUGUI_WID_TITLEBAR_BUTTON_1	2




/* Chained Text Structure*/
typedef struct _muGUIChainedText {

	char * text;		//the text
	
	void * previous;	//point to previous text
	void * next;		//point to next text	


} muGUIChainedText;


/*WIDGET Structure*/
typedef struct _muGUIwidget {
	
	unsigned int	ID;			//ID
	unsigned char	Type;		//Type

	char	Title[56];			//Widget Title
	
	int				x;			//x position to the main GUI Surface ( Including TitleBar )
	int				y;			//y position to the main GUI Surface ( Including TitleBar )
	unsigned int	w;			//width ( Including TitleBar + Internal)
	unsigned int	h;			//height ( Including TitleBar + Internal)
	
	int				previous_x;	//Same as above
	int				previous_y;
	unsigned int	previous_w;
	unsigned int	previous_h;
	
	unsigned char	moved;
	
	
	unsigned char	Status;		//Widget Internal Status
	unsigned char	NeedRefresh;//Widget Refresh Status
	

	
	/* functions Pointer for all Widget*/	
	void (*external_draw)	( void * this , void * fgui );
	void (*internal_draw)	( void * this , void * fgui );
	int  (*isClick)			( void * this , void * fgui , int fx , int fy);
	void (*freeMem)			( void * this );
	
	
	/*Image Widget*/
	SDL_Surface * image;	//Surface of the Widget Image	
	void (*addImage)		( void * this , SDL_Surface * surface );	//Add a Surface to Widget
	
	
	/*Text Widget*/
	muGUIChainedText 		*TextBuffer;							//Chained Text list 
	void (*addText)			( void * this , char * ftext );			//add Text functions
	unsigned int 			maxLines;								//nimber of lines to display
	unsigned int 			displayAtLine;							//start display at line
	

} muGUIwidget;



/* Functions Declarations */

/*For All Widget*/
void 	muGUIwidget_init 			( muGUIwidget * fwid, unsigned char ftype, int fx, int fy, unsigned int fw, 
									unsigned int fh, char * fTitle );

void 	muGUIwidget_external_draw 			( void * this, void * fgui );
void 	muGUIwidget_default_internal_draw 	( void * this, void * fgui );
void 	muGUIwidget_null_external_draw 		( void * this , void * fgui ) ;
int 	muGUIwidget_isClick_TitleBar 		( void * this, void * fgui, int fx , int fy);
void 	muGUIwidget_FreeDefault 			( void * this );


/*for Image Widget*/
void 	muGUIwidget_attachImage 					( void * this, SDL_Surface * surface );
void 	muGUIwidget_image_internal_draw 			( void * this, void * fgui ) ;
void 	muGUIwidget_image_internal_draw_fullscreen 	( void * this , void * fgui ) ;
void 	muGUIwidget_FreeImage 						( void * this );

/*for Text Widget*/
void 	muGUIwidget_addText 				( void * this, char * ftext ) ;
void 	muGUIwidget_printAllText 			( void * this );
void 	muGUIwidget_text_internal_draw 		( void * this, void * fgui ) ;
void 	muGUIwidget_FreeAllText 			( void * this );


void muGUIwidget_state_internal_draw ( void * this , void * fgui ) ;
void muGUIwidget_attachTrace ( void * this , void * fData , int ftype) ;