/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "nSX2.h"

#include "iniparser/iniparser.h"

_u16	muGUI_MainScreenW;
_u16	muGUI_MainScreenH;
_u16	muGUI_MainScreenBPP;
_u16	muGUI_MainScreenStretch;


int nSX2LoadConfig ( void ) {


	dictionary	*	ini ;
	char		*	s ;
	
	ini = iniparser_load(nSX2ConfigFile);
	if (ini==NULL) {
		fprintf(stderr, "cannot parse file [%s]", nSX2ConfigFile);
		return -1 ;
	}


	s = iniparser_getstr(ini, "General:Elf");
	if (s) {
		strcpy(ElfToExecute,s);
	} else {
		strcpy(ElfToExecute,"");
	}
	

	debug_op = iniparser_getint(ini, "General:Debug_op", 0);

	debug_dma = iniparser_getint(ini, "General:Debug_dma", 0);
		
	debug_print_syscall = iniparser_getint(ini, "General:Debug_syscall", 0);

	debug_gs = iniparser_getint(ini, "General:Debug_GS", 0);

	muGUI_MainScreenW = iniparser_getint(ini, "Video:Width", 320);	
		
	muGUI_MainScreenH = iniparser_getint(ini, "Video:Height", 240);		
	
	muGUI_MainScreenBPP = iniparser_getint(ini, "Video:Bpp", 32);			

	muGUI_MainScreenStretch = iniparser_getint(ini, "Video:Stretch", 1);			
	
	iniparser_freedict(ini);	
		
	return TRUE;
}



