#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

#include "../../nSX2.h"
#include "../GS.h"
#include "../../iniparser/iniparser.h"


void SaveConfig() {
    FILE *f;
    char cfg[255];

    sprintf (cfg, "%s/.PS2E", getenv("HOME"));
	mkdir(cfg, 0x755);
    sprintf (cfg, "%s/.PS2E/GSsoftx.cfg", getenv("HOME"));
    f = fopen(cfg,"w");
    if (f == NULL) return;
    fwrite(&conf, 1, sizeof(conf), f);
    fclose(f);
}

void LoadConfig() {

	dictionary	*	ini ;
	char		*	s ;
	


	memset(&conf, 0, sizeof(conf));

	
	
	ini = iniparser_load(nSX2ConfigFile);
	if (ini==NULL) {
		fprintf(stderr, "cannot parse file [%s]", nSX2ConfigFile);
		return  ;
	}


	s = iniparser_getstr(ini, "General:Elf");
	if (s) strcpy(ElfToExecute,s);
	else strcpy(ElfToExecute,"");
	
	conf.mode.width = iniparser_getint(ini, "Video:Width", 320);	
	conf.mode.height = iniparser_getint(ini, "Video:Height", 240);		
	conf.mode.bpp = iniparser_getint(ini, "Video:Bpp", 32);			
	conf.stretch = iniparser_getint(ini, "Video:Stretch", 1);			
	
	iniparser_freedict(ini);	
		

	
	conf.fullscreen  = 0;

}

