/**
 * nSX2 - an OpenSource PS2 Emulator
 * Copyright (C) 2002 Muad
 *
 * homepage: http://nsx2.emulation64.com
 * email address: atreides.muaddib@caramail.com
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/



char * debug_r5900_reg [34] = {
"r0", "at", "v0", "v1", "a0", "a1", "a2", "a3",
"t0", "t1", "t2", "t3", "t4", "t5", "t6", "t7",
"s0", "s1", "s2", "s3", "s4", "s5", "s6", "s7",
"t8", "t9",
"k0", "k1",
"gp", "sp",
"s8",
"ra",
"hi", "lo"
};	

char * debug_r5900_cop1_reg [32] = {
"fp0",	"fp1",	"fp2",	"fp3",	"fp4",	"fp5",	"fp6",	"fp7",
"fp8",	"fp9",	"fp10",	"fp11",	"fp12",	"fp13",	"fp14",	"fp15", 
"fp16",	"fp17",	"fp18",	"fp19",	"fp20",	"fp21",	"fp22",	"fp23",
"fp24", "fp25",	"fp26",	"fp27",	"fp28",	"fp29",	"fp30",	"fp31"
};	

char * debug_r5900_cop0_reg [32] = {
	"Index",			"Random",	"EntryLo0",	"EntryLo1",	"Context",		"PageMask",		"Wired",	" ", 	
	"BadWAddr",			"Count",	"EntryHi",	"Compare",	"Status",		"Cause",		"EPC",		"PRiD",
	"Config/Config1",	" ",		"WatchLo",	"WatchHi",	"XContext",		" ", 			" ", 		"Debug",				
	"DEPC",				"PerfCnt",	"ErrCtl",	"CacheErr", "TagLo/DataLo",	"TagHi/DataHi",	"ErrorEPC",	"DESAVE"
};




static void (*normal_opc[64])(void) =
{
   SPECIAL,	REGIMM,		J,		JAL,	BEQ,		BNE,	BLEZ,	BGTZ,
   ADDI, 	ADDIU, 		SLTI,	SLTIU,	ANDI,		ORI,	XORI,	LUI,
   COP0, 	COP1, 		COP2,	NI,		BEQL,		BNEL,	BLEZL,	BGTZL,
   DADDI, 	DADDIU, 	LDL,	LDR,	SPECIAL2,	NI,		LQ,		SQ,
   LB, 		LH, 		LWL,	LW,		LBU,		LHU,	LWR,	LWU,
   SB, 		SH, 		SWL,	SW,		SDL,		SDR,	SWR,	CACHE,
   NI, 		LWC1, 		NI,		PREF,	NI,			NI,		LQC2,	LD,
   NI, 		SWC1, 		NI,		NI,		NI, 		NI,		SQC2,	SD
};

static void (*pnormal_opc[64])(void) =
{
   pSPECIAL,	pREGIMM,	pJ,		pJAL,	pBEQ,		pBNE,	pBLEZ,	pBGTZ,
   pADDI, 		pADDIU, 	pSLTI,	pSLTIU,	pANDI,		pORI,	pXORI,	pLUI,
   pCOP0, 		pCOP1, 		pCOP2,	pNI,	pBEQL,		pBNEL,	pBLEZL,	pBGTZL,
   pDADDI, 		pDADDIU, 	pLDL,	pLDR,	pSPECIAL2,	pNI,	pLQ,	pSQ,
   pLB, 		pLH, 		pLWL,	pLW,	pLBU,		pLHU,	pLWR,	pLWU,
   pSB, 		pSH, 		pSWL,	pSW,	pSDL,		pSDR,	pSWR,	pCACHE,
   pNI, 		pLWC1, 		pNI,	pPREF,	pNI,		pNI,	pLQC2,	pLD,
   pNI, 		pSWC1, 		pNI,	pNI,	pNI, 		pNI,	pSQC2,	pSD
};


char * debug_normal_opc[64] =
{
   "SPECIAL",	"REGIMM",	"J",	"JAL",		"BEQ",		"BNE",	"BLEZ",		"BGTZ",
   "ADDI",		"ADDIU",	"SLTI",	"SLTIU",	"ANDI",		"ORI",	"XORI", 	"LUI",
   "COP0",		"COP1",		"COP2",	"NI",		"BEQL",		"BNEL",	"BLEZL", 	"BGTZL",
   "DADDI",		"DADDIU",	"LDL",	"LDR",		"SPECIAL2",	"NI",	"LQ", 		"SQ",
   "LB",		"LH",		"LWL",	"LW",		"LBU",		"LHU",	"LWR",		"LWU",
   "SB",		"SH",		"SWL",	"SW",		"SDL",		"SDR",	"SWR",		"CACHE",
   "NI",		"LWC1",		"NI",	"PREF",		"NI",		"NI",	"LQC2",		"LD",
   "NI",		"SWC1",		"NI",	"NI",		"NI",		"NI",	"SQC2",		"SD"
};



static void (*special_opc[64])(void) =
{
   SLL,		NI,		SRL,	SRA,	SLLV,		NI,		SRLV,	SRAV,
   JR,		JALR,	MOVZ,	MOVN,	SYSCALL,	BREAK,	NI,		SYNC,
   MFHI,	MTHI,	MFLO,	MTLO,	DSLLV,		NI,		DSRLV,	DSRAV,
   MULT,	MULTU,	DIV,	DIVU,	NI,			NI,		NI,		NI,
   ADD,		ADDU,	SUB,	SUBU,	AND,		OR,		XOR,	NOR,
   MFSA,	MTSA,	SLT,	SLTU,	DADD,		DADDU,	DSUB,	DSUBU,
   TGE,		TGEU,	TLT,	TLTU,	TEQ,		NI,		TNE,	NI,
   DSLL,	NI,		DSRL,	DSRA,	DSLL32,		NI,		DSRL32,	DSRA32
};

static void (*pspecial_opc[64])(void) =
{
   pSLL,	pNI,	pSRL,	pSRA,	pSLLV,		pNI,	pSRLV,	pSRAV,
   pJR,		pJALR,	pMOVZ,	pMOVN,	pSYSCALL,	pBREAK,	pNI,	pSYNC,
   pMFHI,	pMTHI,	pMFLO,	pMTLO,	pDSLLV,		pNI,	pDSRLV,	pDSRAV,
   pMULT,	pMULTU,	pDIV,	pDIVU,	pNI,		pNI,	pNI,	pNI,
   pADD,	pADDU,	pSUB,	pSUBU,	pAND,		pOR,	pXOR,	pNOR,
   pMFSA,	pMTSA,	pSLT,	pSLTU,	pDADD,		pDADDU,	pDSUB,	pDSUBU,
   pTGE,	pTGEU,	pTLT,	pTLTU,	pTEQ,		pNI,	pTNE,	pNI,
   pDSLL,	pNI,	pDSRL,	pDSRA,	pDSLL32,	pNI,	pDSRL32,pDSRA32
};

char * debug_special_opc[64] =
{
   "SLL",	"NI",		"SRL",	"SRA",	"SLLV",		"NI",		"SRLV",		"SRAV",
   "JR",	"JALR ",	"MOVZ",	"MOVN",	"SYSCALL",	"BREAK",	"NI",		"SYNC",
   "MFHI",	"MTHI",		"MFLO",	"MTLO",	"DSLLV",	"NI",		"DSRLV",	"DSRAV",
   "MULT",	"MULTU", 	"DIV",	"DIVU",	"NI",		"NI",		"NI",		"NI",
   "ADD",	"ADDU", 	"SUB",	"SUBU",	"AND",		"OR",		"XOR",		"NOR",
   "MFSA",	"MTSA",		"SLT",	"SLTU",	"DADD",		"DADDU",	"DSUB",		"DSUBU",
   "TGE",	"TGEU", 	"TLT",	"TLTU",	"TEQ",		"NI",		"TNE",		"NI",
   "DSLL",	"NI", 		"DSRL",	"DSRA",	"DSLL32",	"NI",		"DSRL32",	"DSRA32"
};



static void (*regimm_opc[32])(void) =
{
   BLTZ,	BGEZ,	BLTZL,		BGEZL,		NI,		NI,	NI,		NI,
   TGEI,	TGEIU, 	TLTI,		TLTIU,		TEQI,	NI,	TNEI,	NI,
   BLTZAL,	BGEZAL, BLTZALL,	BGEZALL,	NI,		NI,	NI,		NI,
   MTSAB,	MTSAH,	NI,			NI,			NI,		NI, NI,		NI 
};

static void (*pregimm_opc[32])(void) =
{
   pBLTZ,	pBGEZ,		pBLTZL,		pBGEZL,		pNI,	pNI,	pNI,	pNI,
   pTGEI,	pTGEIU, 	pTLTI,		pTLTIU,		pTEQI,	pNI,	pTNEI,	pNI,
   pBLTZAL,	pBGEZAL, 	pBLTZALL,	pBGEZALL,	pNI,	pNI,	pNI,	pNI,
   pMTSAB,	pMTSAH,		pNI,		pNI,		pNI,	pNI, 	pNI,	pNI 
};


char * debug_regimm_opc[32] =
{
   "BLTZ",		"BGEZ",		"BLTZL",	"BGEZL",	"NI",	"NI",	"NI",	"NI",
   "TGEI",		"TGEIU", 	"TLTI",		"TLTIU",	"TEQI", "NI",	"TNEI",	"NI",
   "BLTZAL",	"BGEZAL",	"BLTZALL",	"BGEZALL",	"NI",	"NI",	"NI",	"NI",
   "MTSAB",		"MTSAH",	"NI",		"NI",		"NI",	"NI",	"NI",	"NI" 
};

static void (*cop0_opc[32])(void) =
{
	MF0,	NI,		NI,	NI,	MT0,	NI,	NI,	NI,
   	BC0, 	NI, 	NI,	NI,	NI,		NI,		NI, NI,
  	C0,		C0,		C0,	C0,	C0,		C0,		C0,	C0,
	C0,		C0,		C0,	C0,	C0,		C0,		C0,	C0
};

static void (*pcop0_opc[32])(void) =
{
	pMF0,	pNI,	pNI,	pNI,	pMT0,	pNI,	pNI,	pNI,
   	pBC0, 	pNI, 	pNI,	pNI,	pNI,	pNI,	pNI, 	pNI,
  	pC0,	pC0,	pC0,	pC0,	pC0,	pC0,	pC0,	pC0,
	pC0,	pC0,	pC0,	pC0,	pC0,	pC0,	pC0,	pC0
};


char * debug_cop0_opc[32] =
{
   	"MF0", "NI",		"NI",	"NI",	"MT0",	"NI", 	"NI",	"NI",
   	"BC0", 	"NI", 		"NI", 	"NI", 	"NI", 	"NI", 		"NI", 	"NI",
  	"C0",	"C0",		"C0",	"C0",	"C0",	"C0",		"C0",	"C0",
   	"C0",	"C0",		"C0",	"C0",	"C0",	"C0",		"C0",	"C0"
};

static void (*cop0c0_opc[64])(void) =
{
	NI, 	TLBR, 	TLBWI, 	NI, 	NI,		NI,		TLBWR,		NI,
	TLBP,	NI,		NI,		NI,		NI,		NI,		NI,			NI,		
	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,
	ERET, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,	 
 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,
 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,
 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 		NI ,
	EI, 	DI, 	NI, 	NI,		NI, 	NI, 	NI, 		NI  	 
};

static void (*pcop0c0_opc[64])(void) =
{
	pNI, 	pTLBR, 	pTLBWI, pNI, 	pNI,	pNI,	pTLBWR,		pNI,
	pTLBP,	pNI,	pNI,	pNI,	pNI,	pNI,	pNI,		pNI,		
	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 		pNI ,
	pERET, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 		pNI ,	 
 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 		pNI ,
 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 		pNI ,
 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 		pNI ,
	pEI, 	pDI, 	pNI, 	pNI,	pNI, 	pNI, 	pNI, 		pNI  	 
};


char * debug_cop0c0_opc[64] =
{
	"NI", 	"TLBR", "TLBWI", 	"NI", 	"NI",	"NI",	"TLBWR",	"NI",
	"TLBP",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",		
	"NI",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"ERET",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"NI",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"NI",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"NI",	"NI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI",
	"EI",	"DI",	"NI",		"NI",	"NI",	"NI",	"NI",		"NI" 	 
};

static void (*syscall_fct[256])(void) =
{
//0
SYSCALL_RFU000_FullReset, 		SYSCALL_ResetEE, 				SYSCALL_SetGsCrt, 			SYSCALL_RFU003,
SYSCALL_Exit,					SYSCALL_RFU005, 				SYSCALL_LoadPS2Exe, 		SYSCALL_ExecPS2, 
//8
SYSCALL_RFU008, 				SYSCALL_RFU009, 				SYSCALL_AddSbusIntcHandler,	SYSCALL_RemoveSbusIntcHandler, 	
SYSCALL_Interrupt2Iop, 			SYSCALL_SetVTLBRefillHandler, 	SYSCALL_SetVCommonHandler, 	SYSCALL_SetVInterruptHandler, 
//16
SYSCALL_AddIntcHandler, 		SYSCALL_RemoveIntcHandler, 		SYSCALL_AddDmacHandler, 	SYSCALL_RemoveDmacHandler,
SYSCALL__EnableIntc, 			SYSCALL__DisableIntc, 			SYSCALL__EnableDmac, 		SYSCALL__DisableDmac, 
//24
SYSCALL__SetAlarm, 				SYSCALL__ReleaseAlarm, 			SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
//32
SYSCALL_CreateThread,			SYSCALL_DeleteThread, 			SYSCALL_StartThread, 		SYSCALL_ExitThread,
SYSCALL_ExitDeleteThread, 		SYSCALL_TerminateThread, 		SYSCALL_NI, 				SYSCALL_DisableDispatchThread,
//40
SYSCALL_EnableDispatchThread,	SYSCALL_ChangeThreadPriority,	SYSCALL_NI, 				SYSCALL_RotateThreadReadyQueue,
SYSCALL_NI, 					SYSCALL_ReleaseWaitThread, 		SYSCALL_NI, 				SYSCALL_GetThreadId, 
//48
SYSCALL_ReferThreadStatus, 		SYSCALL_NI, 					SYSCALL_SleepThread, 		SYSCALL_WakeupThread,
SYSCALL_NI, 					SYSCALL_CancelWakeupThread, 	SYSCALL_NI, 				SYSCALL_SuspendThread, 
//56
SYSCALL_NI, 					SYSCALL_ResumeThread, 			SYSCALL_NI, 				SYSCALL_JoinThread,
SYSCALL_RFU060, 				SYSCALL_RFU061, 				SYSCALL_EndOfHeap, 			SYSCALL_RFU063, 
//64
SYSCALL_CreateSema, 			SYSCALL_DeleteSema, 			SYSCALL_SignalSema, 		SYSCALL_NI,
SYSCALL_WaitSema, 				SYSCALL_PollSema, 				SYSCALL_NI, 				SYSCALL_ReferSemaStatus, 
//72
SYSCALL_NI, 					SYSCALL_RFU073, 				SYSCALL_SetOsdConfigParam, 	SYSCALL_GetOsdConfigParam,
SYSCALL_GetGsHParam, 			SYSCALL_GetGsVParam, 			SYSCALL_SetGsHParam, 		SYSCALL_SetGsVParam, 
//80
SYSCALL_RFU080_CreateEventFlag,	SYSCALL_RFU081_DeleteEventFlag,	SYSCALL_RFU082_SetEventFlag,SYSCALL_RFU083_iSetEventFlag,
SYSCALL_RFU084_ClearEventFlag, 	SYSCALL_RFU085_iClearEventFlag, SYSCALL_RFU086_WaitEvnetFlag,SYSCALL_RFU087_PollEvnetFlag, 
//88
SYSCALL_RFU088_iPollEvnetFlag, 	SYSCALL_RFU089_ReferEventFlagStatus,SYSCALL_NI,				SYSCALL_RFU091,
SYSCALL_EnableIntcHandler, 		SYSCALL_DisableIntcHandler, 	SYSCALL_EnableDmacHandler, 	SYSCALL_DisableDmacHandler, 
//96
SYSCALL_KSeg0, 					SYSCALL_EnableCache, 			SYSCALL_DisableCache, 		SYSCALL_GetCop0,
SYSCALL_FlushCache, 			SYSCALL_NI, 					SYSCALL_CpuConfig, 			SYSCALL_NI, 
//104
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_sceSifStopDma, 
SYSCALL_SetCPUTimerHandler, 	SYSCALL_SetCPUTimer, 			SYSCALL_ForceRead, 			SYSCALL_ForceWrite, 
//112
SYSCALL_GsGetIMR, 				SYSCALL_GsPutIMR, 				SYSCALL_SetPgifHandler, 	SYSCALL_SetVSyncFlag,
SYSCALL_RFU116, 				SYSCALL_print, 					SYSCALL_sceSifDmaStat, 		SYSCALL_sceSifSetDma, 
//120
SYSCALL_sceSifSetDChain, 		SYSCALL_sceSifSetReg, 			SYSCALL_sceSifGetReg, 		SYSCALL_ExecOSD, 
SYSCALL_Deci2Call, 				SYSCALL_PSMode, 				SYSCALL_MachineType, 		SYSCALL_GetMemorySize, 
//128
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 
//136
SYSCALL_isceSifSetDChain, 		SYSCALL_isceSifSetDma, 			SYSCALL_isceSifDmaStat, 	SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_iGsPutIMR, 
//144
SYSCALL_iGsGetIMR, 				SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI,			 			SYSCALL_iCpuConfig, 		SYSCALL_NI, 
//152
SYSCALL_iFlushCache,	 		SYSCALL_iGetCop0, 				SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_UKN_1, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
//160
SYSCALL_NI, 					SYSCALL_iDisableDmacHandler,	SYSCALL_iEnableDmacHandler,	SYSCALL_iDisableIntcHandler,
SYSCALL_iEnableIntcHandler, 	SYSCALL_NI, 					SYSCALL_RFU090_iReferEventFlagStatus, SYSCALL_NI,
//168
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI,					SYSCALL_NI,
//176
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
//184
SYSCALL_iReferSemaStatus, 		SYSCALL_NI, 					SYSCALL_iPollSema, 			SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_iSignalSema, 			SYSCALL_NI, 				SYSCALL_NI,
//192
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_iResumeThread, 		SYSCALL_NI,
//200
SYSCALL_iSuspendThread, 		SYSCALL_NI, 					SYSCALL_iCancelWakeupThread,SYSCALL_NI,
SYSCALL_iWakeupThread, 			SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_iReferThreadStatus,
//208
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_iReleaseWaitThread, SYSCALL_NI,
SYSCALL_iRotateThreadReadyQueue,SYSCALL_NI, 					SYSCALL_iChangeThreadPriority,SYSCALL_NI,
//216
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_iTerminateThread, 	SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI, 		
//224
SYSCALL_NI, 					SYSCALL__iReleaseAlarm, 		SYSCALL__iSetAlarm, 		SYSCALL__iDisableDmac,
SYSCALL__iEnableDmac, 			SYSCALL__iDisableIntc, 			SYSCALL__iEnableIntc, 		SYSCALL_NI,
//232
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
//240
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
//248
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI,
SYSCALL_NI, 					SYSCALL_NI, 					SYSCALL_NI, 				SYSCALL_NI 

	          
};


char * debug_syscall[256] =
{
"SYSCALL_RFU000_FullReset", 	"SYSCALL_ResetEE", 				"SYSCALL_SetGsCrt", 			"SYSCALL_RFU003",
"SYSCALL_Exit", 				"SYSCALL_RFU005", 				"SYSCALL_LoadPS2Exe", 			"SYSCALL_ExecPS2", 
"SYSCALL_RFU008", 				"SYSCALL_RFU009", 				"SYSCALL_AddSbusIntcHandler", 	"SYSCALL_RemoveSbusIntcHandler",
"SYSCALL_Interrupt2Iop",		"SYSCALL_SetVTLBRefillHandler", "SYSCALL_SetVCommonHandler", 	"SYSCALL_SetVInterruptHandler", 
"SYSCALL_AddIntcHandler", 		"SYSCALL_RemoveIntcHandler", 	"SYSCALL_AddDmacHandler", 		"SYSCALL_RemoveDmacHandler",
"SYSCALL__EnableIntc", 			"SYSCALL__DisableIntc", 		"SYSCALL__EnableDmac", 			"SYSCALL__DisableDmac", 
"SYSCALL__SetAlarm", 			"SYSCALL__ReleaseAlarm", 		"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 
"SYSCALL_CreateThread",			"SYSCALL_DeleteThread", 		"SYSCALL_StartThread", 			"SYSCALL_ExitThread",
"SYSCALL_ExitDeleteThread", 	"SYSCALL_TerminateThread", 		"SYSCALL_NI", 					"SYSCALL_DisableDispatchThread", 	
"SYSCALL_EnableDispatchThread", "SYSCALL_ChangeThreadPriority",	"SYSCALL_NI", 					"SYSCALL_RotateThreadReadyQueue", 
"SYSCALL_NI", 					"SYSCALL_ReleaseWaitThread", 	"SYSCALL_NI", 					"SYSCALL_GetThreadId", 
"SYSCALL_ReferThreadStatus", 	"SYSCALL_NI", 					"SYSCALL_SleepThread", 			"SYSCALL_WakeupThread",
"SYSCALL_NI", 					"SYSCALL_CancelWakeupThread", 	"SYSCALL_NI", 					"SYSCALL_SuspendThread", 
"SYSCALL_NI", 					"SYSCALL_ResumeThread", 		"SYSCALL_NI", 					"SYSCALL_JoinThread",
"SYSCALL_RFU060", 				"SYSCALL_RFU061", 				"SYSCALL_EndOfHeap", 			"SYSCALL_RFU063", 
"SYSCALL_CreateSema", 			"SYSCALL_DeleteSema", 			"SYSCALL_SignalSema", 			"SYSCALL_NI",
"SYSCALL_WaitSema", 			"SYSCALL_PollSema", 			"SYSCALL_NI", 					"SYSCALL_ReferSemaStatus", 
"SYSCALL_NI", 					"SYSCALL_RFU073", 				"SYSCALL_SetOsdConfigParam", 	"SYSCALL_GetOsdConfigParam", 	
"SYSCALL_GetGsHParam", 			"SYSCALL_GetGsVParam", 			"SYSCALL_SetGsHParam", 			"SYSCALL_SetGsVParam", 
"SYSCALL_RFU080_CreateEventFlag","SYSCALL_RFU081_DeleteEventFlag","SYSCALL_RFU082_SetEventFlag","SYSCALL_RFU083_iSetEventFlag", 
"SYSCALL_RFU084_ClearEventFlag","SYSCALL_RFU085_iClearEventFlag","SYSCALL_RFU086_WaitEvnetFlag","SYSCALL_RFU087_PollEvnetFlag", 
"SYSCALL_RFU088_iPollEvnetFlag","SYSCALL_RFU089_ReferEventFlagStatus", "SYSCALL_NI", 			"SYSCALL_RFU091",
"SYSCALL_EnableIntcHandler", 	"SYSCALL_DisableIntcHandler", 	"SYSCALL_EnableDmacHandler", 	"SYSCALL_DisableDmacHandler", 
"SYSCALL_KSeg0", 				"SYSCALL_EnableCache", 			"SYSCALL_DisableCache", 		"SYSCALL_GetCop0",
"SYSCALL_FlushCache", 			"SYSCALL_NI", 					"SYSCALL_CpuConfig", 			"SYSCALL_NI", 
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_sceSifStopDma",
"SYSCALL_SetCPUTimerHandler", 	"SYSCALL_SetCPUTimer", 			"SYSCALL_ForceRead", 			"SYSCALL_ForceWrite",
"SYSCALL_GsGetIMR", 			"SYSCALL_GsPutIMR", 			"SYSCALL_SetPgifHandler", 		"SYSCALL_SetVSyncFlag",
"SYSCALL_RFU116", 				"SYSCALL_print", 				"SYSCALL_sceSifDmaStat", 		"SYSCALL_sceSifSetDma", 
"SYSCALL_sceSifSetDChain", 		"SYSCALL_sceSifSetReg", 		"SYSCALL_sceSifGetReg", 		"SYSCALL_ExecOSD",
"SYSCALL_Deci2Call", 			"SYSCALL_PSMode", 				"SYSCALL_MachineType", 			"SYSCALL_GetMemorySize", 
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 
"SYSCALL_isceSifSetDChain", 	"SYSCALL_isceSifSetDma", 		"SYSCALL_isceSifDmaStat", 		"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_iGsPutIMR", 
"SYSCALL_iGsGetIMR", 			"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_iCpuConfig", 			"SYSCALL_NI", 
"SYSCALL_iFlushCache", 			"SYSCALL_iGetCop0", 			"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_UKN_1", 				"SYSCALL_NI",					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_iDisableDmacHandler", 	"SYSCALL_iEnableDmacHandler", 	"SYSCALL_iDisableIntcHandler",
"SYSCALL_iEnableIntcHandler", 	"SYSCALL_NI", 					"SYSCALL_RFU090_iReferEventFlagStatus", "SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_iReferSemaStatus", 	"SYSCALL_NI", 					"SYSCALL_iPollSema", 			"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_iSignalSema", 			"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_iResumeThread", 		"SYSCALL_NI",
"SYSCALL_iSuspendThread", 		"SYSCALL_NI", 					"SYSCALL_iCancelWakeupThread", 	"SYSCALL_NI",
"SYSCALL_iWakeupThread", 		"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_iReferThreadStatus",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_iReleaseWaitThread", 	"SYSCALL_NI",
"SYSCALL_iRotateThreadReadyQueue","SYSCALL_NI", 				"SYSCALL_iChangeThreadPriority", "SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_iTerminateThread", 	"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 		
"SYSCALL_NI", 					"SYSCALL__iReleaseAlarm", 		"SYSCALL__iSetAlarm", 			"SYSCALL__iDisableDmac",
"SYSCALL__iEnableDmac", 		"SYSCALL__iDisableIntc", 		"SYSCALL__iEnableIntc", 		"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI",
"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI", 					"SYSCALL_NI" 


};



static void (*special2_opc[64])(void) =
{
	MADD,	MADDU,	NI,		NI,		PLZCW,	NI,		NI,		NI,	
	MMI0,	MMI2,	NI,		NI,		NI,		NI,		NI,		NI,	
	MFHI1,	MTHI1,	MFLO1,	MTLO1,	NI,		NI,		NI,		NI,	
	MULT1,	MULTU1,	DIV1,	DIVU1,	NI,		NI,		NI,		NI,	
	MADD1,	MADDU1,	NI,		NI,		NI,		NI,		NI,		NI,	
	MMI1,	MMI3,	NI,		NI,		NI,		NI,		NI,		NI,	
	PMFHL,	PMTHL,	NI,		NI,		PSLLH,	NI,		PSRLH,	PSRAH,	
	NI,		NI,		NI,		NI,		PSLLW,	NI,		PSRLW,	PSRAW							
};

static void (*pspecial2_opc[64])(void) =
{
	pMADD,	pMADDU,	pNI,	pNI,	pPLZCW,	pNI,		pNI,		pNI,	
	pMMI0,	pMMI2,	pNI,	pNI,	pNI,	pNI,		pNI,		pNI,	
	pMFHI1,	pMTHI1,	MFLO1,	pMTLO1,	pNI,	pNI,		pNI,		pNI,	
	pMULT1,	pMULTU1,pDIV1,	pDIVU1,	pNI,	pNI,		pNI,		pNI,	
	pMADD1,	pMADDU1,pNI,	pNI,	pNI,	pNI,		pNI,		pNI,	
	pMMI1,	pMMI3,	pNI,	pNI,	pNI,	pNI,		pNI,		pNI,	
	pPMFHL,	pPMTHL,	pNI,	pNI,	pPSLLH,	pNI,		pPSRLH,	pPSRAH,	
	pNI,	pNI,	pNI,	pNI,	pPSLLW,	pNI,		pPSRLW,	pPSRAW							
};


char * debug_special2_opc[64] =
{
	"MADD",	"MADDU",	"NI",	"NI",	"PLZCW","NI",	"NI",	"NI",	
	"MMI0",	"MMI2",		"NI",	"NI",	"NI",	"NI",	"NI",	"NI",	
	"MFHI1","MTHI1",	"MFLO1","MTLO1","NI",	"NI",	"NI",	"NI",	
	"MULT1","MULTU1",	"DIV1",	"DIVU1","NI",	"NI",	"NI",	"NI",	
	"MADD1","MADDU1",	"NI",	"NI",	"NI",	"NI",	"NI",	"NI",	
	"MMI1",	"MMI3",		"NI",	"NI",	"NI",	"NI",	"NI",	"NI",	
	"PMFHL","PMTHL",	"NI",	"NI",	"PSLLH","NI",	"PSRLH","PSRAH",	
	"NI",	"NI",		"NI",	"NI",	"PSLLW","NI",	"PSRLW","PSRAW"							
};

static void (*cop1_opc[32])(void) =
{
	MFC1,	NI,		CFC1,	NI,		MTC1,	NI,		CTC1,	NI,
	BC1, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI,
	COP1_S,	NI, 	NI, 	NI, 	COP1_W,	NI,		NI, 	NI,
	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI, 	NI							
};

static void (*pcop1_opc[32])(void) =
{
	pMFC1,	pNI,	pCFC1,	pNI,	pMTC1,	pNI,	pCTC1,	pNI,
	pBC1, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI,
	pCOP1_S,pNI, 	pNI, 	pNI, 	pCOP1_W,pNI,	pNI, 	pNI,
	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI, 	pNI							
};

char * debug_cop1_opc[32] =
{
	"MFC1",		"NI",	"CFC1",	"NI",	"MTC1",		"NI",	"CTC1",	"NI",
	"BC1",		"NI", 	"NI", 	"NI", 	"NI", 		"NI",	"NI", 	"NI",
	"COP1_S",	"NI", 	"NI", 	"NI", 	"COP1_W",	"NI",	"NI", 	"NI",
	"NI", 		"NI", 	"NI", 	"NI", 	"NI", 		"NI",	"NI", 	"NI"							
};


static void (*cop1_bc1_opc[4])(void) =
{
	BC1F, BC1T,
	BC1FL,BC1TL
};

static void (*pcop1_bc1_opc[4])(void) =
{
	pBC1F, pBC1T,
	pBC1FL,pBC1TL
};

char * debug_cop1_bc1_opc[4] =
{
	"BC1F", "BC1T",
	"BC1FL","BC1TL"
};

static void (*cop1_s_opc[64])(void) =
{
	ADD_S, 		SUB_S, 		MUL_S, 		DIV_S, 		SQRT_S, 	ABS_S, 		MOV_S, 		NEG_S,
	NI,			NI,			NI,			NI,			NI,			NI,			NI,			NI,
	NI,			NI,			NI,			NI,			NI,			NI,		 	RSQRT_S,  	NI,
	ADDA_S, 	SUBA_S,		MULA_S,		NI, 		MADD_S,		MSUB_S,		MADDA_S,	MSUBA_S,		
	NI,			NI, 		NI, 		NI,			CVT_W_S,	NI,			NI,			NI,
	MAX_S, 		MIN_S, 		NI, 		NI, 		NI, 		NI, 		NI, 		NI,		
	C_F_S, 		NI,			C_EQ_S,		NI	,		C_OLT_S,	NI,			C_OLE_S,	NI,
	NI,			NI, 		NI,			NI,			NI,			NI,			NI,			NI
};

static void (*pcop1_s_opc[64])(void) =
{
	pADD_S, 		pSUB_S, 	pMUL_S, 	pDIV_S, 	pSQRT_S, 	pABS_S, 	pMOV_S, 	pNEG_S,
	pNI,			pNI,		pNI,		pNI,		pNI,		pNI,		pNI,		pNI,
	pNI,			pNI,		pNI,		pNI,		pNI,		pNI,		pRSQRT_S,  	pNI,
	pADDA_S, 		pSUBA_S,	pMULA_S,	pNI, 		pMADD_S,	pMSUB_S,	pMADDA_S,	pMSUBA_S,		
	pNI,			pNI, 		pNI, 		pNI,		pCVT_W_S,	pNI,		pNI,		pNI,
	pMAX_S, 		pMIN_S, 	pNI, 		pNI, 		pNI, 		pNI, 		pNI, 		pNI,		
	pC_F_S, 		pNI,		pC_EQ_S,	pNI	,		pC_OLT_S,	pNI,		pC_OLE_S,	pNI,
	pNI,			pNI, 		pNI,		pNI,		pNI,		pNI,		pNI,		pNI
};


char * debug_cop1_s_opc[64] =
{
	"ADD_S", 	"SUB_S", 	"MUL_S", 	"DIV_S", 	"SQRT_S", 	"ABS_S", 	"MOV_S", 	"NEG_S",
	"NI",		"NI",		"NI",		"NI",		"NI",		"NI",		"NI",		"NI",
	"NI",		"NI",		"NI",		"NI",		"NI",		"NI",  		"RSQRT_S", 	"NI",
	"ADDA_S", 	"SUBA_S", 	"MULA_S", 	"NI", 		"MADD_S", 	"MSUB_S", 	"MADDA_S", 	"MSUBA_S",		
	"NI",		"NI", 		"NI", 		"NI",		"CVT_W_S",	"NI",		"NI",		"NI",
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",		
	"C_F_S", 	"NI",		"C_EQ_S",	"NI",		"C_OLT_S",	"NI",		"C_OLE_S",	"NI",
	"NI",		"NI", 		"NI",		"NI",		"NI",		"NI",		"NI",		"NI"
};


static void (*cop1_W_L_opc[64])(void) =
{
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	CVTS_W,		NI,			NI, 	NI, 		NI, 		NI, 		NI, 	NI, 			
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI,		
	NI, 		NI, 		NI, 	NI, 		NI, 		NI, 		NI, 	NI		
};

static void (*pcop1_W_L_opc[64])(void) =
{
	pNI, 		pNI, 		pNI, 	pNI, 		pNI, 		pNI, 		pNI, 	pNI,		
	pNI, 		pNI, 		pNI, 	pNI, 		pNI, 		pNI, 		pNI, 	pNI,		
	pNI, 		pNI, 		pNI, 	pNI, 		pNI, 		pNI, 		pNI, 	pNI,		
	pNI, 		pNI, 		pNI, 	pNI, 		pNI, 		pNI, 		pNI, 	pNI,		
	pCVTS_W,	pNI,		pNI, 	pNI, 		pNI, 		pNI, 		pNI, 	pNI, 			
	pNI, 		pNI, 		pNI, 	pNI, 		pNI, 		pNI, 		pNI, 	pNI,		
	pNI, 		pNI, 		pNI, 	pNI, 		pNI, 		pNI, 		pNI, 	pNI,		
	pNI, 		pNI, 		pNI, 	pNI, 		pNI, 		pNI, 		pNI, 	pNI		
};


char * debug_cop1_W_L_opc[64] =
{
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"CVT_S",	"NI",		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI",	
	"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI", 		"NI"	
	
};
	
static void (*cop1_movcf_opc[2])(void) =	
{
	MOVF_fmt, MOVT_fmt	
};

static void (*pcop1_movcf_opc[2])(void) =	
{
	pMOVF_fmt, pMOVT_fmt	
};	

char * debug_cop1_movcf_opc[2] =
{
	"MOVF_fmt", "MOVT_fmt"	
};

